c-----
c       perform linear regression
c       However a or b can be fixed
c-----
c       CHANGES
c       07 JUN 2017 - changed output format for L1 in dolinw
c           to use upper  case letters for better grepping
c-----
        character*10 a,b,c,d,e,asave
        real*4 x
        logical dofixa, dofixb, dol1
        real fixa, fixb
        call gcmdln(dofixa,dofixb,fixa,fixb,dol1)
        if(dol1)then
            open(2,file='xy.res',status='unknown',
     1      form='formatted',access='sequential')
        endif
          
        call getdat(ndat)
        call dolinreg(dofixa,dofixb,fixa,fixb,ndat,dol1,sd)
        if(dol1)then
           call dolinw(dofixa,dofixb,fixa,fixb,ndat,dol1,.false.,sd)
           call dolinw(dofixa,dofixb,fixa,fixb,ndat,dol1,.false.,sd)
           call dolinw(dofixa,dofixb,fixa,fixb,ndat,dol1,.true.,sd)
           close(2)
        endif
        close (1)
        end

        subroutine getdat(ndat)
        integer ndat
            open(1,file='xy.tmp',status='unknown',
     1      form='formatted',access='sequential')
            rewind 1
            ndat = 0
 1000       continue
c-----
c           read in groups of three
c-----
            read(5,*,end=9999)x,y
            ndat = ndat + 1
            write(1,*)x,y
            go to 1000
 9999       continue
        return
        end

        subroutine dolinreg(dofixa,dofixb,fixa,fixb,ndat,dol1,sd)
        logical dofixa,dofixb,dol1
        real fixa, fixb
        integer ndat

        real sumn, sumx, sumy, sumxx, sumxy, sumyy
        real xbar, ybar
        real a11,a12,a21,a22,det,sxx,syy,sxy
        real aa,bb,sum2, sum3, erra2, errb2
c-----
c       read in values perform regression
c-----
        sumn = 0.0
        sumx = 0.0
        sumxx = 0.0
        sumy = 0.0
        sumyy = 0.0
        sumxy = 0.0
        rewind 1
        do i=1,ndat
             read(1,*)x,y
c----
c            buildup regression sums
c----
                sumn = sumn + 1.0
                sumx = sumx + x
                sumxx = sumxx + x**2
                sumy = sumy + y
                sumyy = sumyy + y**2
                sumxy = sumxy + y*x
        enddo
c----
c       perform regression
c----
        write(6,*)'sum =',sumn
        write(6,*)'sumx =',sumx
        write(6,*)'sumxx =',sumxx
        write(6,*)'sumy =',sumy
        write(6,*)'sumyy =',sumyy
        write(6,*)'sumxy =',sumxy
        xbar = sumx/sumn
        ybar = sumy/sumn
        write(6,*)'xbar  =',xbar
        write(6,*)'ybar  =',ybar
        sxx = sumxx - sumn*xbar*xbar
        syy = sumyy - sumn*ybar*ybar
        sxy=sumxy - sumn*xbar*ybar
        r = sxy/sqrt(sxx*syy)
        write(6,*)'r     =',r
        a11 = sumn
        a12 = sumx
        a21 = sumx
        a22 = sumxx
        b1 = sumy
        b2 = sumxy
c-----
c       fix
c-----
        if(dofixa)then
            b2 = b2 - a21*fixa
            a11 = 1.0
            a12 = 0.0
            a21 = 0.0
            b1  = fixa
        endif
        if(dofixb)then
            b1 = b1 - a12*fixb
            a22 = 1.0
            a12 = 0.0
            a21 = 0.0
            b2 = fixb
        endif
        det = a11*a22 - a21*a12
        aa = ( a22*b1 - a12*b2)/det
        bb = (-a21*b1 + a11*b2)/det
        sum2 = sumyy + aa*aa*sumn + bb*bb*sumxx -2.*aa*sumy
     1  -2.*bb*sumxy + 2.*aa*bb*sumx
        sum3 = sumyy - aa*sumy - bb*sumxy
        sd = sqrt(sum3/(sumn-2))
        write(6,*)'sigma2 =:', sum2,sum3
        erra2 = sum2 * a22/(det* (sumn-2))
        errb2 = sum2 * a11/(det * (sumn-2))
        write(6,*)'det=',det
        write(6,*)'aa = ',aa
        write(6,*)'sda=',sqrt(erra2)
        write(6,*)'bb = ',bb
        write(6,*)'sdb=',sqrt(errb2)
c-----
c       if dol1 is true then save the residuals
c-----
        if(dol1)then
            rewind 2
            rewind 1
            do i=1,ndat
               read(1,*)x,y
               write(2,*)  y - aa - bb*x     
            enddo
        endif
     
        return
        end

        subroutine gcmdln(dofixa,dofixb,fixa,fixb,dol1)
        logical dofixa, dofixb,dol1
        real fixa, fixb
        character name*20
        dofixa = .false.
        dofixb = .false.
        dol1   = .false.
        nmarg = numarg()
        i = 0
 1000   continue
            i = i + 1
            if(i.gt.nmarg)go to 9000
            call getarg(i,name)
            if(name(1:2).eq.'-A')then
                i = i + 1
                call getarg(i,name)
                read(name,'(f10.0)')fixa
                dofixa = .true.
            else if(name(1:2).eq.'-B')then
                i = i + 1
                call getarg(i,name)
                read(name,'(f10.0)')fixb
                dofixb = .true.
            else if(name(1:2).eq.'-1')then
                dol1 = .true.
            else if(name(1:2).eq.'-h')then
                call usage()
            endif
        go to 1000
 9000   continue
        return
        end

        subroutine usage()
        integer LER
        parameter (LER=0)
        WRITE(LER,*)
     1  '  linreg:  read x,y pairs from standard input to fit ',
     2  '     to tbe model Y= A + B X'
        WRITE(LER,*)'USAGE: ',
     1  ' -A fixa -B fixb -1 -h'
        WRITE(LER,*)
     1  ' -A  aval              Fix A in regression, else A is free'
        WRITE(LER,*)
     1  ' -B  aval              Fix B in regression, else B is free'
        WRITE(LER,*)
     1  ' -1  (default false)   Apply 3 iterations of iterative L1 '
        WRITE(LER,*)
     2  '    where weight is related to  1/|MAX(residual,eps)|'
        WRITE(LER,*)
     3  '    and eps= 0.1 L2 Std.dev or 0.1 average residual'
        write(LER,*)
     1  ' -h           Write this help message'
        stop
        end


        function numarg()
        integer numarg
        numarg = iargc()
        return
        end
        
        
        subroutine dolinw(dofixa,dofixb,fixa,fixb,ndat,dol1,doprnt,sd)
c-----
c       MIN SUM | y - beta x |  by iteratively solving
c                  i        i
c       MIN SUM w ( y - beta x )^2  where w 1/max(delta, | res  |)
c                i   i        i            i                  i
c       https://en.wikipedia.org/wiki/Iteratively_reweighted_least_squares
c       Gentle, James (2007). "6.8.1 Solutions that Minimize Other Norms 
c         of the Residuals". Matrix algebra. New York: Springer. 
c         doi:10.1007/978-0-387-70873-7. ISBN 978-0-387-70872-0.
c         LOC QA276?
c-----
c       do a weighted regression using the 1/|residual|
c       to implement an L1
c-----
        logical dofixa,dofixb,dol1,doprnt
        real fixa, fixb
        integer ndat

        real sumn, sumx, sumy, sumxx, sumxy, sumyy
        real xbar, ybar
        real a11,a12,a21,a22,det,sxx,syy,sxy
        real aa,bb,sum2, sum3, erra2, errb2
c-----
c       get bounds on residuals
c-----
        rmax = 0.0
        rmin = 1.0e+38
        rmean = 0.0
        rewind 2
        do i=1,ndat
            read(2,*)res
            if(abs(res).gt.rmax)rmax = abs(res)
            if(abs(res).lt.rmin)rmin = abs(res)
            rmean = rmean + abs(res)
        enddo
        rmean = rmean/ndat
        if(rmean.eq.0.0)rmean = 1.0       
        eps = 0.1*sd
        if(eps.lt.0.1*rmean)eps=0.1*rmean
        rewind 2
c-----
c       read in values perform regression
c-----
        sumn = 0.0
        sumx = 0.0
        sumxx = 0.0
        sumy = 0.0
        sumyy = 0.0
        sumxy = 0.0
        rewind 1
        do i=1,ndat
             read(1,*)x,y
             read(2,*)res
c-- the lower bound is for the problem of Ml vs distance
             wt = (1./amax1(abs(res),eps))
              
             
c----
c            buildup regression sums
c----
                sumn  = sumn  + wt
                sumx  = sumx  + wt*x
                sumxx = sumxx + wt*x**2
                sumy  = sumy  + wt*y
                sumyy = sumyy + wt*y**2
                sumxy = sumxy + wt*y*x
        enddo
c----
c       perform regression
c----
C        write(6,*)'sum =',sumn
C        write(6,*)'sumx =',sumx
C        write(6,*)'sumxx =',sumxx
C        write(6,*)'sumy =',sumy
C        write(6,*)'sumyy =',sumyy
C        write(6,*)'sumxy =',sumxy
        xbar = sumx/sumn
        ybar = sumy/sumn
C        write(6,*)'xbar  =',xbar
C        write(6,*)'ybar  =',ybar
        sxx = sumxx - sumn*xbar*xbar
        syy = sumyy - sumn*ybar*ybar
        sxy=sumxy - sumn*xbar*ybar
        r = sxy/sqrt(sxx*syy)
C        write(6,*)'r     =',r
        a11 = sumn
        a12 = sumx
        a21 = sumx
        a22 = sumxx
        b1 = sumy
        b2 = sumxy
c-----
c       fix
c-----
        if(dofixa)then
            b2 = b2 - a21*fixa
            a11 = 1.0
            a12 = 0.0
            a21 = 0.0
            b1  = fixa
        endif
        if(dofixb)then
            b1 = b1 - a12*fixb
            a22 = 1.0
            a12 = 0.0
            a21 = 0.0
            b2 = fixb
        endif
        det = a11*a22 - a21*a12
        aa = ( a22*b1 - a12*b2)/det
        bb = (-a21*b1 + a11*b2)/det
        sum2 = sumyy + aa*aa*sumn + bb*bb*sumxx -2.*aa*sumy
     1  -2.*bb*sumxy + 2.*aa*bb*sumx
        sum3 = sumyy - aa*sumy - bb*sumxy
        erra2 = sum2 * a22/(det* (sumn))
        errb2 = sum2 * a11/(det * (sumn))
        if(doprnt)then
        write(6,*)'-----'
        write(6,*)'SUM    =',sumn
        write(6,*)'SUMX   =',sumx
        write(6,*)'SUMXX  =',sumxx
        write(6,*)'SUMY   =',sumy
        write(6,*)'SUMYY  =',sumyy
        write(6,*)'SUMXY  =',sumxy
        write(6,*)'XBAR   =',xbar
        write(6,*)'YBAR   =',ybar
        write(6,*)'R      =',r
        write(6,*)'SIGMA2 =', sum2,sum3
        write(6,*)'DET    =',det
        write(6,*)'AA     =',aa
        write(6,*)'SDA    =',sqrt(erra2)
        write(6,*)'BB     =',bb
        write(6,*)'SDB    =',sqrt(errb2)
        endif
c-----
c       if dol1 is true then save the residuals
c-----
        if(dol1)then
            rewind 2
            rewind 1
            do i=1,ndat
               read(1,*)x,y
               write(2,*)  y - aa - bb*x     
            enddo
        endif
     
        return
        end
